/******************************************************************************
*                                                                             *
*    Colors.h                               Copyright(c) 2007-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef COLORS_H
#define COLORS_H


// F̎
enum ColorType {
	COLOR_TYPE_CUSTOM,
	COLOR_TYPE_BLACK,
	COLOR_TYPE_BROWN,
	COLOR_TYPE_GREEN,
	COLOR_TYPE_OLIVE,
	COLOR_TYPE_DARKBLUE,
	COLOR_TYPE_DARKMAGENTA,
	COLOR_TYPE_DARKCYAN,
	COLOR_TYPE_GRAY,
	COLOR_TYPE_SILVER,
	COLOR_TYPE_RED,
	COLOR_TYPE_LIME,
	COLOR_TYPE_YELLOW,
	COLOR_TYPE_BLUE,
	COLOR_TYPE_MAGENTA,
	COLOR_TYPE_CYAN,
	COLOR_TYPE_WHITE,
	COLOR_TYPE_WINDOW,
	COLOR_TYPE_WINDOWTEXT,
	COLOR_TYPE_HIGHLIGHT,
	COLOR_TYPE_HIGHLIGHTTEXT,
	COLOR_TYPE_APPWORKSPACE,
	COLOR_TYPE_DESKTOP,
	COLOR_TYPE_3DFACE,
	COLOR_TYPE_3DLIGHT,
	COLOR_TYPE_3DHIGHLIGHT,
	COLOR_TYPE_3DSHADOW,
	COLOR_TYPE_3DDARKSHADOW,
	COLOR_TYPE_BUTTONTEXT,
	COLOR_TYPE_MENU,
	COLOR_TYPE_MENUTEXT,
	COLOR_TYPE_ACTIVECAPTION,
	COLOR_TYPE_ACTIVECAPTIONTEXT,
	COLOR_TYPE_INACTIVECAPTION,
	COLOR_TYPE_INACTIVECAPTIONTEXT,
	COLOR_TYPE_INFOBACK,
	COLOR_TYPE_INFOTEXT
};

#define COLOR_TYPE_SYSCOLORFIRST COLOR_TYPE_WINDOW

typedef DWORD ColorInfo;
#define PackColorInfo(type,r,g,b) (((type)<<24)|((r)<<16)|((g)<<8)|(b))
#define ColorInfo_GetType(Color) ((ColorType)((Color)>>24))
#define ColorInfo_SetType(pColor,type) \
								(*(pColor)=(*(pColor)&0x00FFFFFF)|((type)<<24))
#define ColorInfo_GetCustomRed(Color) (((Color)>>16)&0xFF)
#define ColorInfo_GetCustomGreen(Color) (((Color)>>8)&0xFF)
#define ColorInfo_GetCustomBlue(Color) ((Color)&0xFF)
#define ColorInfo_GetCustomColor(Color) \
						RGB(((Color)>>16)&0xFF,((Color)>>8)&0xFF,(Color)&0xFF)
#define ColorInfo_SetCustomColor(pColor,r,g,b) \
					(*(pColor)=(*(pColor)&0xFF000000)|((r)<<16)|((g)<<8)|(b))

COLORREF ColorInfo_GetColor(ColorInfo Color);
LPTSTR ColorInfo_GetText(ColorInfo Color,LPTSTR pszText);
BOOL ColorInfo_Parse(ColorInfo *pColor,LPCTSTR pszText);
BOOL ColorInfo_EqualColor(ColorInfo Color1,ColorInfo Color2);

void ColorsComboBox_Init(HWND hDlg,int nID,ColorInfo Color);
ColorInfo ColorsComboBox_GetColor(HWND hDlg,int nID);
void ColorsComboBox_SetColor(HWND hDlg,int nID,ColorInfo Color);
BOOL ColorsComboBox_OnMeasureItem(HWND hDlg,WPARAM wParam,LPARAM lParam);
BOOL ColorsComboBox_OnDrawItem(HWND hDlg,WPARAM wParam,LPARAM lParam);
BOOL ColorsComboBox_ChooseColor(HWND hDlg,int nID);


#endif	// ndef COLORS_H
