/******************************************************************************
*                                                                             *
*    MediaMCI.cpp                           Copyright(c) 2005-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#define NOCOMPMAN	// vfw.h  dwICValue ɒ`Ȃ悤ɂ
#include <vfw.h>
#include <digitalv.h>	// for MCI_DGV_XXXX
#include "LafPlayer.h"
#include "MediaMCI.h"
#include "Util.h"
#include "resource.h"


#define MCI_MEDIA_FORM_WINDOW_CLASS TEXT("LafPlayer MCI Form")

#define MediaPtr(hwnd) ((MCIMedia*)GetWindowLongPtr(hwnd,0))




bool MCIMedia::Init(HINSTANCE hinst)
{
	static bool fInitialized=false;
	WNDCLASS wc;

	if (fInitialized)
		return true;
	wc.style=0;
	wc.lpfnWndProc=FormWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=sizeof(MCIMedia*);
	wc.hInstance=hinst;
	wc.hIcon=NULL;
	wc.hCursor=NULL;//LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=MCI_MEDIA_FORM_WINDOW_CLASS;
	if (RegisterClass(&wc)==0)
		return false;
	fInitialized=true;
	return true;
}


LRESULT CALLBACK MCIMedia::MCIWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_MOUSEMOVE:
	case WM_DROPFILES:
		return SendMessage(GetParent(hwnd),uMsg,wParam,lParam);

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT)
			return SendMessage(GetParent(hwnd),WM_SETCURSOR,wParam,lParam);
		break;
	}
	return CallWindowProc(MediaPtr(GetParent(hwnd))->m_pOldMCIProc,hwnd,uMsg,
																wParam,lParam);
}


LRESULT CALLBACK MCIMedia::FormWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			LPCREATESTRUCT pmcs=(LPCREATESTRUCT)lParam;
			MCIMedia *pMedia=(MCIMedia*)pmcs->lpCreateParams;

			SetWindowLongPtr(hwnd,0,(LONG_PTR)pMedia);
			pMedia->m_hwndMCI=MCIWndCreate(hwnd,pmcs->hInstance,
				WS_CHILD | WS_VISIBLE | MCIWNDF_NOMENU | MCIWNDF_NOPLAYBAR |
				MCIWNDF_NOTIFYMODE | MCIWNDF_NOTIFYPOS | MCIWNDF_NOTIFYMEDIA/* |
							MCIWNDF_NOERRORDLG | MCIWNDF_NOTIFYERROR*/,NULL);
			if (pMedia->m_hwndMCI==NULL)
				return -1;
			// t@C̃hbvƉENbŇoł悤ɃTuNX
			pMedia->m_pOldMCIProc=SubclassWindow(pMedia->m_hwndMCI,MCIWndProc);
			//DragAcceptFiles(m_hwndMCI,TRUE);
			// ^C}[ݒ肷
			MCIWndSetTimers(pMedia->m_hwndMCI,200,200);
		}
		return 0;

	case WM_SIZE:
		{
			MCIMedia *pMedia=MediaPtr(hwnd);

			MoveWindow(pMedia->m_hwndMCI,0,0,LOWORD(lParam),HIWORD(lParam),TRUE);
		}
		return 0;

	case WM_LBUTTONDOWN:
		SendMessage(GetParent(hwnd),WM_MEDIA_NOTIFY,MEDIA_NOTIFY_LBUTTONDOWN,0);
		return 0;

	case WM_RBUTTONDOWN:
		SendMessage(GetParent(hwnd),WM_MEDIA_NOTIFY,MEDIA_NOTIFY_RBUTTONDOWN,0);
		return 0;

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT)
			return SendMessage(GetParent(hwnd),WM_SETCURSOR,wParam,lParam);
		break;

	case WM_MOUSEMOVE:
		{
			MCIMedia *pMedia=MediaPtr(hwnd);
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			MapWindowPoints(hwnd,GetParent(hwnd),&pt,1);
			SendMessage(GetParent(hwnd),WM_MOUSEMOVE,0,MAKELPARAM(pt.x,pt.y));
		}
		return 0;

	/*
	case WM_PARENTNOTIFY:
		switch (LOWORD(wParam)) {
		case WM_LBUTTONDOWN:
			MediaPtr(hwnd)->SendNotify(MEDIA_NOTIFY_LBUTTONDOWN,0);
			break;
		case WM_RBUTTONDOWN:
			MediaPtr(hwnd)->SendNotify(MEDIA_NOTIFY_RBUTTONDOWN,0);
			break;
		}
		return 0;
	*/

	case MCIWNDM_NOTIFYMODE:
		{
			MCIMedia *pMedia=MediaPtr(hwnd);
			MediaMode Mode;

			switch (lParam) {
			case MCI_MODE_PLAY:		Mode=MEDIA_MODE_PLAY;	break;
			case MCI_MODE_STOP:		Mode=MEDIA_MODE_STOP;	break;
			case MCI_MODE_PAUSE:	Mode=MEDIA_MODE_PAUSE;	break;
			default:
				return 0;
			}
			pMedia->m_Mode=Mode;
			pMedia->SendNotify(MEDIA_NOTIFY_MODE,(LPARAM)Mode);
		}
		return 0;

	case MCIWNDM_NOTIFYPOS:
		{
			MCIMedia *pMedia=MediaPtr(hwnd);

			pMedia->SendNotify(MEDIA_NOTIFY_POS,lParam);
		}
		return 0;

	case WM_DESTROY:
		{
			MCIMedia *pMedia=MediaPtr(hwnd);

			pMedia->Close();
			SubclassWindow(pMedia->m_hwndMCI,pMedia->m_pOldMCIProc);
			pMedia->m_hwnd=NULL;
			pMedia->m_hwndMCI=NULL;
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


MCIMedia::MCIMedia()
{
	m_hwndMCI=NULL;
	m_Format=FORMAT_OTHER;
}


MCIMedia::~MCIMedia()
{
	Destroy();
}


bool MCIMedia::Create(HWND hwndParent,int ID,HINSTANCE hinst)
{
	if (m_hwnd!=NULL)
		return true;
	m_hwnd=CreateWindowEx(0,MCI_MEDIA_FORM_WINDOW_CLASS,NULL,
		WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,0,0,0,0,hwndParent,(HMENU)ID,
																hinst,this);
	return m_hwnd!=NULL;
}


void MCIMedia::Destroy()
{
	if (m_hwnd!=NULL)
		DestroyWindow(m_hwnd);
}


bool MCIMedia::Open(LPCTSTR pszFileName)
{
	if (m_fOpened)
		Close();
	if (MCIWndOpen(m_hwndMCI,pszFileName,NULL)!=0)
		return FALSE;
	m_fOpened=true;
	m_Mode=MEDIA_MODE_READY;
	if (HasVideo())
		m_MediaType=MEDIA_VIDEO;
	else
		m_MediaType=MEDIA_SOUND;
	{
		MCI_GETDEVCAPS_PARMS gdcp;

		gdcp.dwItem=MCI_GETDEVCAPS_DEVICE_TYPE;
		mciSendCommand(MCIWndGetDeviceID(m_hwndMCI),MCI_GETDEVCAPS,
											MCI_GETDEVCAPS_ITEM,(DWORD)&gdcp);
		m_Format=FORMAT_OTHER;
		if (gdcp.dwReturn==MCI_DEVTYPE_WAVEFORM_AUDIO) {
			if (waveOutGetVolume((HWAVEOUT)WAVE_MAPPER,&m_OldVolume)==
															MMSYSERR_NOERROR)
				m_Format=FORMAT_WAVE;
		} else if (gdcp.dwReturn==MCI_DEVTYPE_SEQUENCER) {
			if (midiOutGetVolume((HMIDIOUT)MIDI_MAPPER,&m_OldVolume)==
															MMSYSERR_NOERROR)
				m_Format=FORMAT_MIDI;
		}
	}
	if (MCIWndGetTimeFormat(m_hwndMCI,NULL,0)!=MCI_FORMAT_MILLISECONDS)
		MCIWndUseTime(m_hwndMCI);
	if (m_MediaType==MEDIA_VIDEO) {
		SIZE sz;

		// ݒ肵Ȃƃhbvs\ɂȂ݂
		DragAcceptFiles(m_hwndMCI,TRUE);
		if (MCIWndGetZoom(m_hwndMCI)!=100)
			MCIWndSetZoom(m_hwndMCI,100);
		GetDestSize(&sz);
		//MoveWindow(m_hwndMCI,0,0,sz.cx,sz.cy,TRUE);
		SetSize(sz.cx,sz.cy);
	}
	if (HasAudio())
		SetMediaVolume(m_fMute?0:m_Volume);
	Home();
	return true;
}


void MCIMedia::Close()
{
	if (m_fOpened) {
		MCIWndStop(m_hwndMCI);
		MCIWndClose(m_hwndMCI);
		m_fOpened=false;
		m_MediaType=MEDIA_UNDEFINED;
		m_Mode=MEDIA_MODE_UNDEFINED;
		if (m_Format==FORMAT_WAVE)
			waveOutSetVolume((HWAVEOUT)WAVE_MAPPER,m_OldVolume);
		else if (m_Format==FORMAT_MIDI)
			midiOutSetVolume((HMIDIOUT)MIDI_MAPPER,m_OldVolume);
	}
}


bool MCIMedia::Play()
{
	if (!m_fOpened)
		return false;
	if (MCIWndGetSpeed(m_hwndMCI)!=1000)
		MCIWndSetSpeed(m_hwndMCI,1000);
	if (MCIWndGetMode(m_hwndMCI,NULL,0)==MCI_MODE_PAUSE)
		MCIWndResume(m_hwndMCI);
	else
		MCIWndPlay(m_hwndMCI);
	return true;
}


bool MCIMedia::Pause()
{
	if (!m_fOpened)
		return false;
	if (MCIWndGetMode(m_hwndMCI,NULL,0)==MCI_MODE_PAUSE)
		MCIWndResume(m_hwndMCI);
	else
		MCIWndPause(m_hwndMCI);
	return false;
}


bool MCIMedia::Stop()
{
	if (!m_fOpened)
		return false;
	if (MCIWndGetMode(m_hwndMCI,NULL,0)!=MCI_MODE_STOP) {
		MCIWndStop(m_hwndMCI);
		MCIWndHome(m_hwndMCI);
	}
	return true;
}


bool MCIMedia::PrevFrame()
{
	if (m_MediaType==MEDIA_VIDEO
					&& MCIWndGetPosition(m_hwndMCI)>MCIWndGetStart(m_hwndMCI))
		MCIWndStep(m_hwndMCI,-1);
	return true;
}


bool MCIMedia::NextFrame()
{
	if (m_MediaType==MEDIA_VIDEO
					&& MCIWndGetPosition(m_hwndMCI)<MCIWndGetEnd(m_hwndMCI))
		MCIWndStep(m_hwndMCI,1);
	return true;
}


bool MCIMedia::Backward()
{
	if (!m_fOpened || MCIWndGetPosition(m_hwndMCI)<=MCIWndGetStart(m_hwndMCI))
		return false;
	if (MCIWndPlayReverse(m_hwndMCI)!=0)
		return false;
	if (MCIWndSetSpeed(m_hwndMCI,m_BackwardSpeed)!=0)
		return false;
	return false;
}


bool MCIMedia::SetBackwardSpeed(int Speed)
{
	if (Speed<1)
		return false;
	m_BackwardSpeed=Speed;
	return true;
}


bool MCIMedia::Forward()
{
	if (!m_fOpened)
		return false;
	switch (MCIWndGetMode(m_hwndMCI,NULL,0)) {
	case MCI_MODE_STOP:
		MCIWndPlay(m_hwndMCI);
		break;
	case MCI_MODE_PAUSE:
		MCIWndResume(m_hwndMCI);
		break;
	}
	if (MCIWndSetSpeed(m_hwndMCI,m_ForwardSpeed)!=0)
		return false;
	return true;
}


bool MCIMedia::SetForwardSpeed(int Speed)
{
	if (Speed<1)
		return false;
	m_ForwardSpeed=Speed;
	return true;
}


bool MCIMedia::Home()
{
	MCIWndHome(m_hwndMCI);
	return true;
}


bool MCIMedia::End()
{
	MCIWndEnd(m_hwndMCI);
	return true;
}


/*
bool MCIMedia::SetZoom(int Zoom)
{
	if (Zoom<1)
		Zoom=1;
	m_Zoom=Zoom;
	MCIWndSetZoom(m_hwndMCI,Zoom);
	return true;
}
*/


bool MCIMedia::SetMediaVolume(unsigned int Volume)
{
	if (m_Format==FORMAT_OTHER) {
		MCI_DGV_SETAUDIO_PARMS sap;

		sap.dwCallback=0;
		sap.dwItem=MCI_DGV_SETAUDIO_VOLUME;
		sap.dwValue=Volume;
		sap.dwOver=0;
		sap.lpstrAlgorithm=NULL;
		sap.lpstrQuality=NULL;
		return mciSendCommand(MCIWndGetDeviceID(m_hwndMCI),MCI_SETAUDIO,
				MCI_DGV_SETAUDIO_VALUE | MCI_DGV_SETAUDIO_ITEM,(DWORD)&sap)==0;
	} else {
		DWORD dwVol=(Volume*0xFFFF+500)/1000;
		MMRESULT Result;

		dwVol=(dwVol<<16)|dwVol;
		if (m_Format==FORMAT_WAVE)
			Result=waveOutSetVolume((HWAVEOUT)WAVE_MAPPER,dwVol);
		else
			Result=midiOutSetVolume((HMIDIOUT)MIDI_MAPPER,dwVol);
		if (Result!=MMSYSERR_NOERROR)
			return false;
	}
	return true;
}


bool MCIMedia::SetVolume(unsigned int Volume)
{
	if (Volume>1000)
		return false;
	if (m_fMute)
		m_fMute=false;
	if (m_fOpened && HasAudio())
		SetMediaVolume(Volume);
	m_Volume=Volume;
	return true;
}


bool MCIMedia::Mute(bool fMute)
{
	if (m_fMute==fMute)
		return true;
	if (m_fOpened && HasAudio())
		SetMediaVolume(m_fMute?0:m_Volume);
	m_fMute=fMute;
	return true;
}


bool MCIMedia::GetSourceSize(LPSIZE psz)
{
	RECT rc;

	if (m_MediaType!=MEDIA_VIDEO)
		return false;
	MCIWndGetSource(m_hwndMCI,&rc);
	psz->cx=rc.right-rc.left;
	psz->cy=rc.bottom-rc.top;
	return true;
}


bool MCIMedia::GetDestSize(LPSIZE psz)
{
	RECT rc;

	if (m_MediaType!=MEDIA_VIDEO)
		return false;
	MCIWndGetDest(m_hwndMCI,&rc);
	psz->cx=rc.right-rc.left;
	psz->cy=rc.bottom-rc.top;
	return true;
}


MediaPosition MCIMedia::GetLength()
{
	if (!m_fOpened)
		return 0;
	return MCIWndGetLength(m_hwndMCI);
}


MediaPosition MCIMedia::GetStart()
{
	if (!m_fOpened)
		return -1;
	return MCIWndGetStart(m_hwndMCI);
}


MediaPosition MCIMedia::GetEnd()
{
	if (!m_fOpened)
		return -1;
	return MCIWndGetEnd(m_hwndMCI);
}


MediaPosition MCIMedia::GetPosition()
{
	if (!m_fOpened)
		return -1;
	return MCIWndGetPosition(m_hwndMCI);
}


bool MCIMedia::SetPosition(MediaPosition Position)
{
	MCIWndSeek(m_hwndMCI,Position);
	return true;
}


/*
int Media::GetMode()
{
	return MCIWndGetMode(m_hwndMCI,NULL,0);
}
*/


/*
BOOL Media::GetFileName(LPTSTR pszFileName)
{
	if (!m_fOpened)
		return FALSE;
	MCIWndGetFileName(m_hwndMCI,pszFileName,MAX_PATH);
	return TRUE;
}
*/


bool MCIMedia::HasAudio()
{
	MCI_GETDEVCAPS_PARMS gdcp;

	if (!m_fOpened)
		return false;
	gdcp.dwItem=MCI_GETDEVCAPS_HAS_AUDIO;
	mciSendCommand(MCIWndGetDeviceID(m_hwndMCI),MCI_GETDEVCAPS,
											MCI_GETDEVCAPS_ITEM,(DWORD)&gdcp);
	return gdcp.dwReturn!=0;
}


bool MCIMedia::HasVideo()
{
	MCI_GETDEVCAPS_PARMS gdcp;

	if (!m_fOpened)
		return false;
	gdcp.dwItem=MCI_GETDEVCAPS_HAS_VIDEO;
	mciSendCommand(MCIWndGetDeviceID(m_hwndMCI),MCI_GETDEVCAPS,
											MCI_GETDEVCAPS_ITEM,(DWORD)&gdcp);
	if (gdcp.dwReturn==0)
		return false;
	/*
		MPEG Audio Ȃǂ̓foCX̂rfIɑΉĂĂAt@Cɂ̓rf
		ÎŁAƂ肠Kɔ肷B
	*/
	RECT rc;
	rc.right=rc.bottom=0;
	MCIWndGetSource(m_hwndMCI,&rc);
	return rc.right>0 && rc.bottom>0;
}


/*
BOOL Media::CanBackward()
{
	UINT uDeviceID;
	MCI_GETDEVCAPS_PARMS gdcp;

	if (!m_fOpened)
		return FALSE;
	uDeviceID=MCIWndGetDeviceID(m_hwndMCI);
	gdcp.dwItem=MCI_GETDEVCAPS_DEVICE_TYPE;
	if (mciSendCommand(uDeviceID,MCI_GETDEVCAPS,MCI_GETDEVCAPS_ITEM,
															(DWORD)&gdcp)!=0)
		return TRUE;
	switch (gdcp.dwReturn) {
	case MCI_DEVTYPE_VIDEODISC:
		gdcp.dwItem=MCI_VD_GETDEVCAPS_CAN_REVERSE;
		if (mciSendCommand(uDeviceID,MCI_GETDEVCAPS,MCI_GETDEVCAPS_ITEM,
															(DWORD)&gdcp)!=0)
			return TRUE;
		break;
	case MCI_DEVTYPE_ANIMATION:
		gdcp.dwItem=MCI_ANIM_GETDEVCAPS_CAN_REVERSE;
		if (mciSendCommand(uDeviceID,MCI_GETDEVCAPS,MCI_GETDEVCAPS_ITEM,
															(DWORD)&gdcp)!=0)
			return TRUE;
		break;
	default:
		return TRUE;
	}
	return gdcp.dwReturn!=0;
}
*/


void MCIMedia::Move(int x,int y,int Width,int Height)
{
	MoveWindow(m_hwnd,x,y,Width,Height,TRUE);
}


void MCIMedia::SetSize(int Width,int Height)
{
	SetWindowPos(m_hwnd,NULL,0,0,Width,Height,SWP_NOZORDER | SWP_NOMOVE);
}
