/******************************************************************************
*                                                                             *
*    MediaMCI.h                             Copyright(c) 2005-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef MEDIA_MCI_H
#define MEDIA_MCI_H


#include "Media.h"


class MCIMedia : public Media {
	HWND m_hwndMCI;
	WNDPROC m_pOldMCIProc;
	enum FormatType {
		FORMAT_OTHER,
		FORMAT_WAVE,
		FORMAT_MIDI
	};
	FormatType m_Format;
	DWORD m_OldVolume;
	static LRESULT CALLBACK MCIWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam);
	static LRESULT CALLBACK FormWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam);
	bool SetMediaVolume(unsigned int Volume);
	bool HasVideo();
public:
	static bool Init(HINSTANCE hinst);
	MCIMedia();
	~MCIMedia();
	bool Create(HWND hwndParent,int ID,HINSTANCE hinst);
	void Destroy();
	bool Open(LPCTSTR pszFileName);
	void Close();
	bool Play();
	bool Pause();
	bool Stop();
	bool PrevFrame();
	bool NextFrame();
	bool Backward();
	bool Forward();
	bool SetBackwardSpeed(int Speed);
	bool SetForwardSpeed(int Speed);
	bool Home();
	bool End();
	bool SetVolume(unsigned int Volume);
	bool Mute(bool fMute);
	bool GetSourceSize(LPSIZE psz);
	bool GetDestSize(LPSIZE psz);
	MediaPosition GetLength();
	MediaPosition GetStart();
	MediaPosition GetEnd();
	MediaPosition GetPosition();
	bool SetPosition(MediaPosition Position);
	bool HasAudio();
	void Move(int x,int y,int Width,int Height);
	void SetSize(int Width,int Height);
};


#endif	// ndef MEDIA_MCI_H
