/******************************************************************************
*                                                                             *
*    SeekBar.cpp                            Copyright(c) 2007-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <windows.h>
#include <commctrl.h>
#include "SeekBar.h"


#define SEEKBAR_CLASS TEXT("LafPlayer Seek Bar")

#define BORDER_WIDTH 1




LRESULT CALLBACK SeekBar::WndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			SeekBar *pSeekBar=
							(SeekBar*)((LPCREATESTRUCT)lParam)->lpCreateParams;

			SetWindowLongPtr(hwnd,0,(LONG_PTR)pSeekBar);
		}
		return 0;

	case WM_PAINT:
		{
			SeekBar *pSeekBar=GetPointer(hwnd);
			PAINTSTRUCT ps;
#if 1
			RECT rc,rcBack,rcBar,rcKnob,rcKnobSunken;

			BeginPaint(hwnd,&ps);
			GetClientRect(hwnd,&rc);
			rcBack.left=0;
			rcBack.top=0;
			rcBack.right=rc.right;
			rcBack.bottom=(rc.bottom-rc.top-6)/2;
			FillRect(ps.hdc,&rcBack,pSeekBar->m_hbrBack);
			rcBack.top=rcBack.bottom+6;
			rcBack.bottom=rc.bottom;
			FillRect(ps.hdc,&rcBack,pSeekBar->m_hbrBack);
			if (pSeekBar->m_hbrBar==NULL)
				pSeekBar->m_hbrBar=CreateSolidBrush(pSeekBar->m_crBarColor);
			rcBar.top=(rc.bottom-rc.top-6)/2;
			rcBar.bottom=rcBar.top+6;
			rcBar.left=0;
			rcBar.right=1+pSeekBar->m_KnobPos+1;
			DrawEdge(ps.hdc,&rcBar,BDR_SUNKENOUTER,
												BF_LEFT | BF_TOP | BF_BOTTOM);
			rcBar.left=rcBar.right+pSeekBar->m_KnobWidth-2;
			rcBar.right=rc.right;
			DrawEdge(ps.hdc,&rcBar,BDR_SUNKENOUTER,
												BF_RIGHT | BF_TOP | BF_BOTTOM);
			rc.left++;
			rc.top++;
			rc.right--;
			rc.bottom--;
			rcKnob.left=1+pSeekBar->m_KnobPos;
			rcKnob.top=rc.top;
			rcKnob.right=rcKnob.left+pSeekBar->m_KnobWidth;
			rcKnob.bottom=rc.bottom;
			DrawEdge(ps.hdc,&rcKnob,EDGE_RAISED,BF_RECT | BF_MIDDLE);
			rcKnobSunken.left=rcKnob.left+4;
			rcKnobSunken.top=rcKnob.top+4;
			rcKnobSunken.right=rcKnob.right-4;
			rcKnobSunken.bottom=rcKnob.bottom-4;
			DrawEdge(ps.hdc,&rcKnobSunken,BDR_SUNKENOUTER,BF_RECT);
			rcBar.top++;
			rcBar.bottom--;
			if (rcKnob.left>rc.left) {
				rcBar.left=rc.left;
				rcBar.right=rcKnob.left;
				FillRect(ps.hdc,&rcBar,pSeekBar->m_hbrBar);
			}
			if (rcKnob.right<rc.right) {
				rcBar.left=rcKnob.right;
				rcBar.right=rc.right;
				FillRect(ps.hdc,&rcBar,pSeekBar->m_hbrBar);
			}
#else
			RECT rc,rcBack,rcBar,rcKnob;
			HBRUSH hbr,hbrOld;
			HPEN hpen,hpenOld;

			BeginPaint(hwnd,&ps);
			GetClientRect(hwnd,&rc);
			rcBack.left=0;
			rcBack.top=0;
			rcBack.right=rc.right;
			rcBack.bottom=(rc.bottom-rc.top-12)/2;
			FillRect(ps.hdc,&rcBack,pSeekBar->m_hbrBack);
			rcBack.top=rcBack.bottom+12;
			rcBack.bottom=rc.bottom;
			FillRect(ps.hdc,&rcBack,pSeekBar->m_hbrBack);
			if (pSeekBar->m_hbrBar==NULL)
				pSeekBar->m_hbrBar=CreateSolidBrush(pSeekBar->m_crBarColor);
			rcBar.top=(rc.bottom-rc.top-12)/2;
			rcBar.bottom=rcBar.top+12;
			rcBar.left=0;
			rcBar.right=rc.right;
			DrawEdge(ps.hdc,&rcBar,BDR_SUNKENOUTER,BF_RECT);
			rc.left++;
			rc.top++;
			rc.right--;
			rc.bottom--;
			rcKnob.left=1+pSeekBar->m_KnobPos;
			rcKnob.top=rcBar.top+1;
			rcKnob.right=rcKnob.left+pSeekBar->m_KnobWidth;
			rcKnob.bottom=rcBar.bottom-1;
			hbr=CreateSolidBrush(RGB(128,192,255));
			hbrOld=(HBRUSH)SelectObject(ps.hdc,hbr);
			hpen=CreatePen(PS_SOLID,1,pSeekBar->m_crBarColor);
			hpenOld=(HPEN)SelectObject(ps.hdc,hpen);
			Rectangle(ps.hdc,rcKnob.left,rcKnob.top,rcKnob.right,rcKnob.bottom);
			SelectObject(ps.hdc,hpenOld);
			SelectObject(ps.hdc,hbrOld);
			rcBar.top++;
			rcBar.bottom--;
			if (rcKnob.left>rc.left) {
				rcBar.left=rc.left;
				rcBar.right=rcKnob.left;
				FillRect(ps.hdc,&rcBar,pSeekBar->m_hbrBar);
			}
			if (rcKnob.right<rc.right) {
				rcBar.left=rcKnob.right;
				rcBar.right=rc.right;
				FillRect(ps.hdc,&rcBar,pSeekBar->m_hbrBar);
			}
#endif
			EndPaint(hwnd,&ps);
		}
		return 0;

	case WM_SIZE:
		{
			SeekBar *pSeekBar=GetPointer(hwnd);

			pSeekBar->m_KnobWidth=HIWORD(lParam)-2;
			pSeekBar->m_KnobPos=pSeekBar->CalcKnobPos();
		}
		return 0;

	case WM_LBUTTONDOWN:
		{
			SeekBar *pSeekBar=GetPointer(hwnd);
			int x=LOWORD(lParam);

			if (x-BORDER_WIDTH<pSeekBar->m_KnobPos
					|| x-BORDER_WIDTH>=
								pSeekBar->m_KnobPos+pSeekBar->m_KnobWidth) {
				pSeekBar->m_KnobPos=pSeekBar->GetKnobPos(x);
				pSeekBar->m_Pos=pSeekBar->CalcPos(pSeekBar->m_KnobPos);
				InvalidateRect(hwnd,NULL,TRUE);
				UpdateWindow(hwnd);
				pSeekBar->SendPosChangeNotify(TRACK_THUMB);
			}
			pSeekBar->m_DragStartCursorPos=x;
			pSeekBar->m_DragStartKnobPos=pSeekBar->m_KnobPos;
			SetCapture(hwnd);
		}
		return 0;

	case WM_LBUTTONUP:
		if (GetCapture()==hwnd) {
			SeekBar *pSeekBar=GetPointer(hwnd);

			ReleaseCapture();
			pSeekBar->SendPosChangeNotify(TRACK_END);
		}
		return 0;

	case WM_MOUSEMOVE:
		if (GetCapture()==hwnd) {
			SeekBar *pSeekBar=GetPointer(hwnd);
			int KnobPos;

			KnobPos=pSeekBar->m_DragStartKnobPos+
						((SHORT)LOWORD(lParam)-pSeekBar->m_DragStartCursorPos);
			if (KnobPos<0) {
				KnobPos=0;
			} else {
				RECT rc;
				int MaxKnobPos;

				GetClientRect(hwnd,&rc);
				MaxKnobPos=rc.right-rc.left-BORDER_WIDTH*2-
														pSeekBar->m_KnobWidth;
				if (KnobPos>MaxKnobPos)
					KnobPos=MaxKnobPos;
			}
			if (KnobPos!=pSeekBar->m_KnobPos) {
				pSeekBar->m_KnobPos=KnobPos;
				pSeekBar->m_Pos=pSeekBar->CalcPos(KnobPos);
				InvalidateRect(hwnd,NULL,TRUE);
				UpdateWindow(hwnd);
				pSeekBar->SendPosChangeNotify(TRACK_THUMB);
			}
		}
		return 0;

	case WM_RBUTTONDOWN:
		{
			NMHDR nmh;

			nmh.hwndFrom=hwnd;
			nmh.idFrom=GetWindowLong(hwnd,GWL_ID);
			nmh.code=NM_RCLICK;
			SendMessage(GetParent(hwnd),WM_NOTIFY,nmh.idFrom,(LPARAM)&nmh);
		}
		return 0;

	case WM_SYSCOLORCHANGE:
		{
			SeekBar *pSeekBar=GetPointer(hwnd);

			DeleteObject(pSeekBar->m_hbrBack);
			pSeekBar->m_hbrBack=CreateSolidBrush(GetSysColor(COLOR_3DFACE));
		}
		return 0;

	case WM_DESTROY:
		{
			SeekBar *pSeekBar=GetPointer(hwnd);

			pSeekBar->m_hwnd=NULL;
			if (pSeekBar->m_hbrBar!=NULL) {
				DeleteObject(pSeekBar->m_hbrBar);
				pSeekBar->m_hbrBar=NULL;
			}
			DeleteObject(pSeekBar->m_hbrBack);
			pSeekBar->m_hbrBack=NULL;
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


SeekBar* SeekBar::GetPointer(HWND hwnd)
{
	return (SeekBar*)GetWindowLongPtr(hwnd,0);
}


static int MulDivRound(int Multiplicand,int Multiplier,int Divisor)
{
	if (Divisor==0)
		return 0;
	return (int)(((__int64)Multiplicand*Multiplier+Divisor/2)/Divisor);
}


int SeekBar::CalcKnobPos()
{
	int Range=m_Max-m_Min;
	RECT rc;

	if (Range==0)
		return 0;
	GetClientRect(m_hwnd,&rc);
#if 0
	return ((m_Pos-m_Min)*(rc.right-rc.left-BORDER_WIDTH*2-m_KnobWidth)+
																Range/2)/Range;
#else
	return MulDivRound(m_Pos-m_Min,rc.right-rc.left-BORDER_WIDTH*2-m_KnobWidth,
																		Range);
#endif
}


int SeekBar::CalcPos(int KnobPos)
{
	int Range=m_Max-m_Min;
	RECT rc;
	int SlideRange;
	int Pos;

	GetClientRect(m_hwnd,&rc);
	SlideRange=rc.right-rc.left-BORDER_WIDTH*2-m_KnobWidth;
#if 0
	Pos=m_Min+(KnobPos*Range+SlideRange/2)/SlideRange;
#else
	Pos=m_Min+MulDivRound(KnobPos,Range,SlideRange);
#endif
	return Pos<m_Min?m_Min:Pos>m_Max?m_Max:Pos;
}


int SeekBar::GetKnobPos(int x)
{
	int Pos;

	Pos=x-BORDER_WIDTH-m_KnobWidth/2;
	if (Pos<0) {
		Pos=0;
	} else {
		RECT rc;
		int Max;

		GetClientRect(m_hwnd,&rc);
		Max=rc.right-rc.left-BORDER_WIDTH*2-m_KnobWidth;
		if (Pos>Max)
			Pos=Max;
	}
	return Pos;
}


void SeekBar::SendPosChangeNotify(int Type)
{
	SendMessage(GetParent(m_hwnd),WM_HSCROLL,MAKEWPARAM(Type,m_Pos),
															(LPARAM)m_hwnd);
}


bool SeekBar::Init(HINSTANCE hinst)
{
	WNDCLASS wc;

	wc.style=CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=sizeof(SeekBar*);
	wc.hInstance=hinst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=NULL;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=SEEKBAR_CLASS;
	return RegisterClass(&wc)!=0;
}


SeekBar::SeekBar(HWND hwndParent,int ID,unsigned int Style,
						int Left,int Top,int Width,int Height,HINSTANCE hinst)
{
	m_hwnd=CreateWindowEx(0,SEEKBAR_CLASS,NULL,Style,
						Left,Top,Width,Height,hwndParent,(HMENU)ID,hinst,this);
	m_Min=0;
	m_Max=0;
	m_Pos=0;
	m_KnobPos=0;
	m_crBarColor=RGB(0,0,0);
	m_hbrBar=NULL;
	m_hbrBack=CreateSolidBrush(GetSysColor(COLOR_3DFACE));
}


SeekBar::~SeekBar()
{
	if (m_hwnd!=NULL)
		DestroyWindow(m_hwnd);
}


void SeekBar::SetRange(int Min,int Max)
{
	m_Min=Min;
	m_Max=Max;
	m_KnobPos=CalcKnobPos();
	InvalidateRect(m_hwnd,NULL,TRUE);
}


void SeekBar::SetPos(int Pos)
{
	int KnobPos;

	m_Pos=Pos;
	KnobPos=CalcKnobPos();
	if (KnobPos!=m_KnobPos) {
		m_KnobPos=KnobPos;
		InvalidateRect(m_hwnd,NULL,TRUE);
	}
}


void SeekBar::SetBarColor(COLORREF crColor)
{
	m_crBarColor=crColor;
	if (m_hbrBar!=NULL) {
		DeleteObject(m_hbrBar);
		m_hbrBar=NULL;
	}
	InvalidateRect(m_hwnd,NULL,TRUE);
}
