/******************************************************************************
*                                                                             *
*    StatusBar.h                            Copyright(c) 2007-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef STATUSBAR_H
#define STATUSBAR_H


#define MAX_STATUSBAR_TEXT 32


class LPStatusBar {
public:
	enum {
		PART_MODE,
		PART_SIZE,
		PART_TIME
	};
	enum { NUM_PARTS=3 };
	enum {
		NOTIFY_RBUTTONDOWN=1
	};
private:
	HWND m_hwnd;
	HFONT m_hfont;
	int m_ClientHeight;
	int m_Height;
	HBRUSH m_hbrBackground;
	COLORREF m_crTextColor;
	struct {
		int Size;
		int Offset;
		TCHAR Text[MAX_STATUSBAR_TEXT];
	} m_Parts[NUM_PARTS];
	int m_MinFirstPartWidth;
	static LRESULT CALLBACK StatusBarWndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam);
	static LPStatusBar *GetStatusBar(HWND hwnd);
public:
	static BOOL Init();
	LPStatusBar(HWND hwndParent,int ID);
	~LPStatusBar();
	HWND GetHandle() { return m_hwnd; }
	int Height() const { return m_Height; }
	void Show(BOOL fShow);
	void SetText(int Part,LPCTSTR pText);
	void SetSize(int Part,LPCTSTR pText);
	void SetBackgroundColor(COLORREF crColor);
	void SetTextColor(COLORREF crColor);
};


#endif	// ndef STATUSBAR_H
