/******************************************************************************
*                                                                             *
*    Util.cpp                               Copyright(c) 2005-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <windows.h>
#include <commctrl.h>
#include <tchar.h>
#include "LafPlayer.h"
#include "util.h"




/*  : IS_NUMȊO͕R[hˑ */
#define IS_NUM(c) ((c)>='0' && (c)<='9')
#define UPPER_TO_VAL(c) (((c)-'A')+10)
#define LOWER_TO_VAL(c) (((c)-'a')+10)


/*
	𕄍tɕϊ

	:
		(i)pszValue	ϊ镶ւ̃|C^B
		(i)nBase	B
	߂l:
		ϊlԂB
*/
int StrToInt(LPCTSTR pszValue,int nBase/*=10*/)
{
	int nValue;
	LPCTSTR p;

	nValue=0;
	p=pszValue;
	if (*p=='-' || *p=='+')
		p++;
	while (*p!='\0') {
		if (IS_NUM(*p)) {
			if (*p-'0'>=nBase)
				break;
			nValue=nValue*nBase+(*p-'0');
		} else if (IsCharUpper(*p)) {
			if (UPPER_TO_VAL(*p)>=nBase)
				break;
			nValue=nValue*nBase+UPPER_TO_VAL(*p);
		} else if (IsCharLower(*p)) {
			if (LOWER_TO_VAL(*p)>=nBase)
				break;
			nValue=nValue*nBase+LOWER_TO_VAL(*p);
		} else
			break;
		p++;
	}
	return pszValue[0]=='-'?-nValue:nValue;
}


/*
	𕄍Ȃɕϊ

	:
		(i)pszValue	ϊ镶ւ̃|C^B
		(i)nBase	B
	߂l:
		ϊlԂB
*/
unsigned int StrToUInt(LPCTSTR pszValue,int nBase/*=10*/)
{
	unsigned int uValue;
	LPCTSTR p;

	uValue=0;
	p=pszValue;
	while (*p!='\0') {
		if (IS_NUM(*p)) {
			if (*p-'0'>=nBase)
				break;
			uValue=uValue*nBase+(*p-'0');
		} else if (IsCharUpper(*p)) {
			if (UPPER_TO_VAL(*p)>=nBase)
				break;
			uValue=uValue*nBase+UPPER_TO_VAL(*p);
		} else if (IsCharLower(*p)) {
			if (LOWER_TO_VAL(*p)>=nBase)
				break;
			uValue=uValue*nBase+LOWER_TO_VAL(*p);
		} else
			break;
		p++;
	}
	return uValue;
}


/*
	c[o[̃`bvwv̕\/\ݒ肷
*/
BOOL ShowToolbarTipHelp(HWND hwnd,BOOL fShow)
{
	HWND hwndToolTips;

	hwndToolTips=(HWND)SendMessage(hwnd,TB_GETTOOLTIPS,0,0);
	if (hwndToolTips==NULL)
		return FALSE;
	SendMessage(hwndToolTips,TTM_ACTIVATE,fShow,0);
	return TRUE;
}


/*
	OPENFILENAME\̂
*/
void InitOpenFileName(OPENFILENAME *pofn)
{
#if 0
#if _WIN32_WINNT>=0x500
	OSVERSIONINFO osvi;
	BOOL fWindows2000;

	osvi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	fWindows2000=GetVersionEx(&osvi) && osvi.dwMajorVersion>=5;
	pofn->lStructSize=fWindows2000?
							sizeof(OPENFILENAME):OPENFILENAME_SIZE_VERSION_400;
#else
	pofn->lStructSize=sizeof(OPENFILENAME);
#endif
#else
#if _WIN32_WINNT>=0x500
	pofn->lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
	pofn->lStructSize=sizeof(OPENFILENAME);
#endif
#endif
	pofn->hwndOwner=NULL;
	pofn->lpstrCustomFilter=NULL;
	pofn->nFilterIndex=1;
	pofn->lpstrFileTitle=NULL;
	pofn->lpstrInitialDir=NULL;
	pofn->lpstrTitle=NULL;
	pofn->Flags=0;
	pofn->lpstrDefExt=NULL;
#if 0
#if _WIN32_WINNT>=0x0500
	if (fWindows2000) {
		pofn->pvReserved=NULL;
		pofn->dwReserved=0;
		pofn->FlagsEx=0;
	}
#endif
#endif
}


void EnableDlgItem(HWND hDlg,int ID,BOOL fEnable)
{
	EnableWindow(GetDlgItem(hDlg,ID),fEnable);
}


void EnableDlgItems(HWND hDlg,int FirstID,int LastID,BOOL fEnable)
{
	int i;

	for (i=FirstID;i<=LastID;i++)
		EnableDlgItem(hDlg,i,fEnable);
}


void InvalidateDlgItem(HWND hDlg,int ID)
{
	InvalidateRect(GetDlgItem(hDlg,ID),NULL,TRUE);
}


/*
	fBNgƃt@C

	:
		(o)pszFilePath		t@Ci[郁̈ւ̃|C
							^BpszDirectoryƓł\ȂB
		(i)pszDirectory		fBNgւ̃|C^BpszFilePathƓ
							ł\ȂB
		(i)pszFileName		t@Cւ̃|C^B
	߂l:
		t@Cւ̃|C^ԂB
*/
LPTSTR MergeFileName(LPTSTR pszFilePath,LPCTSTR pszDirectory,
														LPCTSTR pszFileName)
{
	LPTSTR q;
	LPCTSTR p;

	q=pszFilePath;
	p=pszDirectory;
#ifndef UNICODE
	while (*p!='\0'){
		if (IsDBCSLeadByteEx(CP_ACP,*p)){
			*q++=*p++;
			*q++=*p++;
		}else{
			*q++=*p;
			if (*p=='\\' && *(p+1)=='\0')
				break;
			p++;
		}
		if (*p=='\0'){
			*q++='\\';
			break;
		}
	}
#else
	while (*p!='\0')
		*q++=*p++;
	if (p>pszDirectory && *(p-1)!='\\')
		*q++='\\';
#endif
	p=pszFileName;
	while ((*q++=*p++)!='\0');
	return pszFilePath;
}


/*
	tpXt@C擾

	:
		(o)pszFileName	t@Ci[郁̈ւ̃|C^B
		(i)pszFilePath	t@C擾镶ւ̃|C^B
	߂l:
		擾t@C̕ւ̃|C^ԂB
*/
LPTSTR GetFileName(LPTSTR pszFileName,LPCTSTR pszFilePath)
{
	lstrcpy(pszFileName,GetFileNamePtr(pszFilePath));
	return pszFileName;
}


/*
	tpXt@Cւ̃|C^擾

	:
		(i)pszFilePath	t@C擾镶ւ̃|C^B
	߂l:
		t@Cւ̃|C^ԂB
*/
LPTSTR GetFileNamePtr(LPCTSTR pszFilePath)
{
	LPCTSTR p,pszFileName;

	pszFileName=pszFilePath;
	p=pszFilePath;
	while (*p!='\0'){
		if (*p=='\\')
			pszFileName=p+1;
#ifndef UNICODE
		else if (IsDBCSLeadByteEx(CP_ACP,*p))
			p++;
#endif
		p++;
	}
	return (LPTSTR)pszFileName;
}


/*
	t@C̃tpXfBNg擾

	:
		(o)pszDirectory	fBNgi[郁̈ւ̃|C^B
		(i)pszFilePath	fBNg擾t@Cւ̃|C^B
	߂l:
		fBNgi[obt@ւ̃|C^B
*/
LPTSTR GetFileDirectory(LPTSTR pszDirectory,LPCTSTR pszFilePath)
{
	LPCTSTR p;
	LPTSTR q;
	int i;

	p=pszFilePath;
	q=pszDirectory;
	while (*p!='\0') {
		for (i=0;p[i]!='\\' && p[i]!='\0';i++)
#ifndef UNICODE
			if (IsDBCSLeadByteEx(CP_ACP,p[i]))
				i++
#endif
			;
		if (p[i]=='\0')
			break;
		for (;i>=0;i--)
			*q++=*p++;
	}
	if (q-pszDirectory>3)
		q--;
	*q='\0';
	return pszDirectory;
}


/*
	t@Cgqւ̃|C^擾

	:
		(i)pszFilePath	gq擾镶ւ̃|C^B
	߂l:
		gqւ̃|C^ԂB
*/
LPTSTR GetFileExtensionPtr(LPCTSTR pszFilePath)
{
	LPCTSTR p,pszExtension;

	pszExtension=NULL;
	p=pszFilePath;
	while (*p!='\0') {
		if (*p=='\\')
			pszExtension=NULL;
		else if (*p=='.')
			pszExtension=p;
#ifndef UNICODE
		if (IsDBCSLeadByteEx(CP_ACP,*p))
			p++;
#endif
		p++;
	}
	return (LPTSTR)(pszExtension!=NULL?pszExtension:p);
}


/*
	fBNg疖\菜

	:
		(i)pszDirectory	\菜fBNgւ̃|C^B
	߂l:
		fBNgւ̃|C^ԂB
*/
LPTSTR RemoveDirectoryBackslash(LPTSTR pszDirectory)
{
#ifndef UNICODE
	LPTSTR p;

	p=pszDirectory;
	while (*p!='\0') {
		if (*p=='\\' && *(p+1)=='\0') {
			if (p-pszDirectory>3)
				*p='\0';
			break;
		}
		if (IsDBCSLeadByteEx(CP_ACP,*p))
			p++;
		p++;
	}
#else
	int nLength=lstrlen(pszDirectory);

	if (nLength>3 && pszDirectory[nLength-1]=='\\')
		pszDirectory[nLength-1]='\0';
#endif
	return pszDirectory;
}


/*
	΃pX擾

	:
		(o)pszAbsolutePath	΃pXi[郁̈ւ̃|C^B
		(i)pszBaseDirectory	fBNg̕ւ̃|C^B
		(i)pszRilativePath	΃pX̕ւ̃|C^B
	߂l:
		΃pXi[̈ւ̃|C^ԂB
*/
LPTSTR GetAbsolutePath(LPTSTR pszAbsolutePath,LPCTSTR pszBaseDirectory,
													LPCTSTR pszRilativePath)
{
	TCHAR szBaseDir[MAX_PATH];
	LPCTSTR p;
	LPTSTR q;

	lstrcpy(szBaseDir,pszBaseDirectory);
	p=pszRilativePath;
	while (*p=='.') {
		if (p[1]=='\\') {
			p+=2;
		} else if (p[1]=='.' && p[2]=='\\') {
			q=GetFileNamePtr(szBaseDir);
			if (q-szBaseDir>3)
				q--;
			*q='\0';
			p+=3;
		} else
			break;
	}
	MergeFileName(pszAbsolutePath,szBaseDir,p);
	return pszAbsolutePath;
}


LPTSTR GetFilePathEllipsis(LPTSTR pszEllipsis,LPCTSTR pszFilePath)
{
	TCHAR szDir[MAX_PATH];
	LPTSTR pszDirName;

	GetFileDirectory(szDir,pszFilePath);
	pszDirName=GetFileNamePtr(szDir);
	if (pszDirName[0]!='\0')
		wsprintf(pszEllipsis,TEXT("...\\%s\\%s"),
									pszDirName,GetFileNamePtr(pszFilePath));
	else	// Root
		lstrcpy(pszEllipsis,pszFilePath);
	return pszEllipsis;
}


/*
	t@C݂邩ׂ
*/
BOOL FileExists(LPCTSTR pszFileName)
{
	HANDLE hFind;
	WIN32_FIND_DATA wfd;

	hFind=FindFirstFile(pszFileName,&wfd);
	if (hFind==INVALID_HANDLE_VALUE)
		return FALSE;
	FindClose(hFind);
	return (wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)==0;
}


/*
	fBNg݂邩ׂ
*/
BOOL DirectoryExists(LPCTSTR pszDirectory)
{
	HANDLE hFind;
	WIN32_FIND_DATA wfd;

	hFind=FindFirstFile(pszDirectory,&wfd);
	if (hFind==INVALID_HANDLE_VALUE)
		return FALSE;
	FindClose(hFind);
	return (wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)!=0;
}


#define IsDigit(c) ((c)>='0' && (c)<='9')
#define IsSpace(c) ((c)==' ')
#define ToUpper(c) (((c)>='a' && (c)<='z')?(c)^0x20:(c))


#if 0


static int CompareNumberString(LPCTSTR *ppszString1,LPCTSTR *ppszString2)
{
	LPCTSTR p1,p2;
	int Bias=0;

	p1=*ppszString1;
	p2=*ppszString2;
	while (*p1=='0')
		p1++;
	while (*p2=='0')
		p2++;
	while (true) {
		if (!IsDigit(*p1)) {
			if (!IsDigit(*p2))
				break;
			while (IsDigit(*++p2));
			Bias=-1;
			break;
		} else if (!IsDigit(*p2)) {
			while (IsDigit(*++p1));
			Bias=1;
			break;
		} else if (*p1<*p2) {
			if (Bias==0)
				Bias=-1;
		} else if (*p1>*p2) {
			if (Bias==0)
				Bias=1;
		}
		p1++;
		p2++;
	}
	if (Bias==0) {
		int Length1,Length2;

		Length1=p1-*ppszString1;
		Length2=p2-*ppszString2;
		if (Length1<Length2)
			Bias=-1;
		else if (Length1>Length2)
			Bias=1;
	}
	*ppszString1=p1;
	*ppszString2=p2;
	return Bias;
}


int StringNumberCompare(LPCTSTR pszString1,LPCTSTR pszString2,
															bool fIgnoreCase)
{
	LPCTSTR p1,p2;
	TCHAR c1,c2;
	int Bias=0,Result;

	p1=pszString1;
	p2=pszString2;
	while (TRUE) {
		/*
		while (IsSpace(c1=*p1))
			p1++;
		while (IsSpace(c2=*p2))
			p2++;
		*/
		c1=*p1;
		c2=*p2;
		if (c1=='\0' && c2=='\0')
			break;
		if (IsDigit(c1) && IsDigit(c2)) {
			Result=CompareNumberString(&p1,&p2);
			if (Bias==0)
				Bias=Result;
			continue;
		}
#ifndef UNICODE
		if (IsDBCSLeadByteEx(CP_ACP,c1)) {
			if (!IsDBCSLeadByteEx(CP_ACP,c2))
				return 1;
			if (c1<c2)
				return -1;
			else if (c1>c2)
				return 1;
			c1=*++p1;
			c2=*++p2;
			if (c1<c2)
				return -1;
			else if (c1>c2)
				return 1;
			p1++;
			p2++;
			continue;
		} else if (IsDBCSLeadByteEx(CP_ACP,c2))
			return -1;
#endif
		if (fIgnoreCase) {
			c1=ToUpper(c1);
			c2=ToUpper(c2);
		}
		if (c1<c2)
			return -1;
		else if (c1>c2)
			return 1;
		p1++;
		p2++;
	}
	return Bias;
}


#else


static int CompareNumberString(LPCTSTR *ppszString1,LPCTSTR *ppszString2)
{
	LPCTSTR p1,p2;
	int bias=0;

	p1=*ppszString1;
	p2=*ppszString2;
	while (true) {
		if (!IsDigit(*p1)) {
			if (!IsDigit(*p2))
				break;
			return -1;
		} else if (!IsDigit(*p2)) {
			return 1;
		} else if (*p1<*p2) {
			if (bias==0)
				bias=-1;
		} else if (*p1>*p2) {
			if (bias==0)
				bias=1;
		}
		p1++;
		p2++;
	}
	*ppszString1=p1;
	*ppszString2=p2;
	return bias;
}


static int CompareZeroSupply(LPCTSTR *ppszString1,LPCTSTR *ppszString2)
{
	LPCTSTR p1,p2;

	p1=*ppszString1;
	p2=*ppszString2;
	while (true) {
		if (!IsDigit(*p1)) {
			if (!IsDigit(*p2))
				break;
			return -1;
		} else if (!IsDigit(*p2)) {
			return 1;
		} else if (*p1<*p2) {
			return -1;
		} else if (*p1>*p2) {
			return 1;
		}
		p1++;
		p2++;
	}
	*ppszString1=p1;
	*ppszString2=p2;
	return 0;
}


int StringNumberCompare(LPCTSTR pszString1,LPCTSTR pszString2,
															bool fIgnoreCase)
{
	LPCTSTR p1,p2;
	TCHAR c1,c2;
	int Result;

	p1=pszString1;
	p2=pszString2;
	while (true) {
		while (IsSpace(c1=*p1))
			p1++;
		while (IsSpace(c2=*p2))
			p2++;
		if (c1=='\0' && c2=='\0')
			break;
		if (IsDigit(c1) && IsDigit(c2)) {
			if (c1=='0' || c2=='0') {
				Result=CompareZeroSupply(&p1,&p2);
				if (Result!=0)
					return Result;
			} else {
				Result=CompareNumberString(&p1,&p2);
				if (Result!=0)
					return Result;
			}
			continue;
		}
#ifndef UNICODE
		if (IsDBCSLeadByteEx(CP_ACP,c1)) {
			if (!IsDBCSLeadByteEx(CP_ACP,c2))
				return 1;
			if (c1<c2)
				return -1;
			else if (c1>c2)
				return 1;
			c1=*++p1;
			c2=*++p2;
			if (c1<c2)
				return -1;
			else if (c1>c2)
				return 1;
			p1++;
			p2++;
			continue;
		} else if (IsDBCSLeadByteEx(CP_ACP,c2))
			return -1;
#endif
		if (fIgnoreCase) {
			c1=ToUpper(c1);
			c2=ToUpper(c2);
		}
		if (c1<c2)
			return -1;
		else if (c1>c2)
			return 1;
		p1++;
		p2++;
	}
	return 0;
}


#endif
